Subject: Re: CCL:Summary of "rotating a density matrix"

From: Aldert Westra Hoekzema <[email-masked]>
Date: Fri, 23 Aug 2002 10:25:25 +0200 (METDST)

Hi Thomas,

I have not read the articles you mention, but solved the problem
of rotating d-functions (6D set) myself around 1993.  Below you
can find the relevant comment cut from a fortran77 program.
Expanding to f-functions (10F set) should be analogous, probably
including the normalization pecularity (see below).

Kind greetings, Aldert

A.J.A. Westra Hoekzema
Leiden Institue of Chemistry
The Netherlands

*----------------------------------------------------------------------
* ROTATE D-FUNCTIONS (LOCATED IN THE ORIGIN)
*
* IDENTIFY THE SET OF 6 D-FUNCTIONS WITH A TWO-DIMENSIONAL TENSOR:
*  D(XX) = T(1,1)      D(XY) = T(1,2) + T(2,1)
*  D(YY) = T(2,2)      D(XZ) = T(1,3) + T(3,1)
*  D(ZZ) = T(3,3)      D(YZ) = T(2,3) + T(3,2)
* WHERE T(I,J) INDICATES A 3X3 TENSOR WITH ELEMENT (I,J) EQUAL TO 1
* AND THE OTHER EIGHT ELEMENTS EQUAL TO 0
*
* A ROTATED TENSOR GIVEN IN TERMS OF THE ORIGINAL TENSOR ELEMENTS
* DEPENDS ON THE ROTATION-MATRIX R:
*                3   3
*  ROT T(I,J) = SUM SUM R(I,K) R(J,L) T(K,L)
*               K=1 L=1
*
*  WITH R(K,I) = PARTIAL DERIVATIVE OF ROTATED CARTESIAN TO OLD ONE
*
* AFTER ROTATION A GENERAL COMBINATION OF D-FUNCTIONS PHI RESULTS IN
* A COMBINATION EXPRESSED IN TERMS OF THE ORIGINAL COEFFICIENTS:
*
*  PHI  = SUM SUM C(IJ) D(IJ)
*          I <= J
*
*  PHI' = ROT PHI = ROT SUM SUM C(IJ) D(IJ) = SUM SUM C(IJ) D(IJ)' =
*                        I <= J                I <= J
*
*         SUM SUM C(IJ) SUM SUM R(I,K) R(J,L) T(K,L) =
*          I <= J         K   L
*
*         SUM SUM SUM SUM C(IJ) { R(I,K) R(J,L) + { DELTA(K,L) - 1 }
*          K <= L  I <= J         R(I,L) R(J,K) } D(KL)
*
*         WITH DELTA THE KRONECKER DELTA
*
* USING THE 6-D SET OF D-FUNCTIONS THERE IS ANOTHER PECULARITY. THE
* NORMALIZATION FACTORS DIFFER BETWEEN D(XX/YY/ZZ) AND D(XY/XZ/YZ):
*
*  N(II) = (1/9) TO THE POWER (1/4) TIMES N(IJ) , J /= I
*
* THIS INTRODUCES A FACTOR IN THE ROTATED COMBINATION:
*
*  PHI' = SUM SUM SUM SUM C(IJ) { R(I,K) R(J,L) + { DELTA(K,L) - 1 }
*          K <= L  I <= J         R(I,L) R(J,K) } D(KL) F(IJ,KL)
*
*  WITH F: II --> KK = 1  ,  II --> KL = SQRT(3)      ,
*          IJ --> KL = 1  ,  IJ --> KK = 1 / SQRT(3)  ,  FOR EXAMPLE:
*
*  ROT DIJ <=> ROT ( N(IJ) IJ EXP ) = .. + N(IJ) KK EXP <=>
*
*  SQRT(3) / SQRT(3) N(IJ) KK EXP <=> SQRT(3) N(KK) KK EXP
*
* A GENERAL EXPRESSION:
*
*  F(IJ,KL) = 1 + DELTA(I,J) { 1 - DELTA(K,L) } { 1 / SQRT(3) - 1 }
*
*               + DELTA(K,L) { 1 - DELTA(I,J) } {     SQRT(3) - 1 }
*
* REFERENCES: -D.E. BOURNE AND P.C. KENDALL,
*              VECTOR ANALYSIS AND CARTESIAN TENSORS, 2ND ED.,
*              NELSON, 1980
*             -GEORGE ARFKEN,
*              MATHEMATICAL METHODS FOR PHYSICISTS, 2ND ED.,
*              ACADEMIC PRESS, 1970
*             -W.J. HEHRE, L. RADOM, P.V.R. SCHLEYER & J.A. POPLE,
*              AB INITIO MOLECULAR ORBITAL THEORY, 1986, P19
*----------------------------------------------------------------------

> From [email-masked]  Fri Aug 23 09:10:08 2002
> From: Thomas Exner <[email-masked]>
> 
> Hi CCLers,
> 
> I have an additional question to the rotation of the density matrix. I
> accounted some difficulties while implementing the rotation of the d
> orbitals as discribed by Ferre et al. (J.Comp.Chem. 23(6) 2002, 610-624)
> and Philipp and Friesner (J.Comp.Chem. 20(14) 1999, 1468-1494). I think
> I found one error in the equation in the second paper. But because I
> don't really understand how the rotation matrix is affiliated, it is
> impossible for me to figure out if there are any other errors in the
> equation or if it is a problem with my implementation. I would
> appriciate if someone could give me some hints how the rotation matrix
> has to be constructed. Perhaps, this could also help me to construct a
> rotation matrix for f orbital. Thank you very much.
> 
> Best wishes,
> Thomas
>    
> -- 
> ____________________________________________________________________
> 
> Dr. Thomas Exner
> Computational, Theoretical & Mathematical Chemistry
> Department of Chemistry 
> University of Saskatchewan
> 110 Science Place                                 431 Edmund Park
> Saskatoon, SK, S7N 5C9                            Saskatoon, SK, S7H 0Z4
> Canada                                            Canada
> 
> phone:  +1-306-966-5357			          +1-306-382-5397
> fax:    +1-306-966-4730
> 
> 
> Department of Physical Chemistry
> Physical Chemistry I 
> Darmstadt University of Technology (TUD)
> Petersenstr. 20                             	  Auf der Marienhoehe 5
> 64287 Darmstadt					  64297 Darmstadt
> Germany						  Germany
> 
> phone:  +49-6151-16 2398			  +49-6151-537165
> fax:    +49-6151-16 4298
> e-mail: [email-masked]		  [email-masked]
> WWW:    http://www.pc.chemie.tu-darmstadt.de/staff/exner/
> ____________________________________________________________________
> 
> 
> -= This is automatically added to each message by mailing script =-
> [email-masked] -- To Everybody  | [email-masked] -- To Admins
> Ftp: ftp.ccl.net  |  WWW: http://www.ccl.net/chemistry/   | Jan: [email-masked]